<script lang="ts" setup>
import { Popover, PopoverButton, PopoverPanel } from '@headlessui/vue';

interface ListItem {
  label: string;
  id: string;
  disabled?: boolean;
}

const props = defineProps<{
  name: string;
  title?: string;
  help?: string;
  options: ListItem[];
  modelValue?: string[];
}>();

const emit = defineEmits<{
  (e: 'update:modelValue', value: string[]): void;
}>();

const allOptionIds = computed(() => {
  return [...new Set(props.options.map((option) => option.id))];
});

const selectAll = ref(false);
const selectedItems = ref<string[]>([...(props.modelValue || [])]);

function handleSelectAll() {
  selectedItems.value = [...allOptionIds.value];
}

function handleClearAll() {
  selectedItems.value = [];
}

watch(selectAll, (newVal) => {
  if (newVal) {
    handleSelectAll();
  }
});

watch(selectedItems, (newVal) => {
  emit('update:modelValue', newVal);
  if (newVal.length === allOptionIds.value.length) {
    selectAll.value = true;
  } else {
    selectAll.value = false;
  }
});
</script>

<template>
  <div class="ecl-form-group mb-4">
    <label for="select-multiple" class="ecl-form-label">
      {{ title }}
    </label>
    <div v-if="help" class="ecl-help-block">{{ help }}</div>
    <Popover as="div" class="ecl-select__multiple">
      <PopoverButton as="template">
        <div class="ecl-select__container">
          <div
            v-if="selectedItems.length > 0"
            class="ecl-select-multiple-selections-counter ecl-select-multiple-selections-counter--visible"
          >
            <span class="selected-counter">{{ selectedItems.length }}</span>
          </div>
          <input
            :value="selectedItems"
            class="ecl-select ecl-select__multiple-toggle"
            type="text"
            placeholder="Select an item"
            readonly="true"
          />
          <div class="ecl-select__icon">
            <svg
              xmlns="http://www.w3.org/2000/svg"
              viewBox="0 0 48 48"
              focusable="false"
              aria-hidden="true"
              class="ecl-icon ecl-icon--s ecl-select__icon-shape ecl-icon--rotate-180"
            >
              <path d="M0 0h48v48H0z" fill="none"></path>
              <path
                d="M40 39 24 21 8 39l-6-6L24 9l22 24-6 6Z"
                fill-rule="evenodd"
              ></path>
            </svg>
          </div>
        </div>
      </PopoverButton>

      <PopoverPanel
        focus
        as="form"
        class="ecl-select__multiple-dropdown ecl-select__container w-100"
      >
        <input
          class="ecl-text-input"
          type="search"
          placeholder="Enter keyword"
        />
        <div class="ecl-select__multiple-all ecl-checkbox">
          <input
            :id="`select-multiple-all--${name}`"
            v-model="selectAll"
            class="ecl-checkbox__input"
            type="checkbox"
          />
          <label
            class="ecl-checkbox__label"
            :for="`select-multiple-all--${name}`"
          >
            <span class="ecl-checkbox__box">
              <svg
                xmlns="http://www.w3.org/2000/svg"
                viewBox="0 0 48 48"
                focusable="false"
                aria-hidden="true"
                class="ecl-icon ecl-icon--s ecl-checkbox__icon"
              >
                <path
                  d="m20 28 16-16 4 4-20 20L8 24l4-4 8 8Z"
                  fill-rule="evenodd"
                ></path>
              </svg>
            </span>
            <span class="ecl-checkbox__label-text">
              Select all ({{ options.length }})
            </span>
          </label>
        </div>
        <div class="ecl-select__multiple-options">
          <div
            v-for="option in options"
            :key="option.id"
            class="ecl-checkbox"
            :class="{ 'ecl-checkbox--disabled': option.disabled }"
            data-select-multiple-value="standalone option"
            data-visible="true"
          >
            <input
              :id="`select-multiple--${name}-${option.id}`"
              v-model="selectedItems"
              class="ecl-checkbox__input"
              type="checkbox"
              :value="option.id"
              :disabled="option.disabled"
            />
            <label
              class="ecl-checkbox__label"
              :for="`select-multiple--${name}-${option.id}`"
            >
              <span class="ecl-checkbox__box">
                <svg
                  xmlns="http://www.w3.org/2000/svg"
                  viewBox="0 0 48 48"
                  focusable="false"
                  aria-hidden="true"
                  class="ecl-icon ecl-icon--s ecl-checkbox__icon"
                >
                  <path
                    d="m20 28 16-16 4 4-20 20L8 24l4-4 8 8Z"
                    fill-rule="evenodd"
                  ></path>
                </svg>
              </span>
              <span class="ecl-checkbox__label-text">{{ option.label }}</span>
            </label>
          </div>
        </div>
        <div class="ecl-select-multiple-toolbar">
          <button
            type="button"
            class="ecl-button ecl-button--ghost"
            @click="handleClearAll"
          >
            Clear all
          </button>
          <PopoverButton as="button" class="ecl-button ecl-button--primary">
            Close
          </PopoverButton>
        </div>
      </PopoverPanel>
    </Popover>
  </div>
</template>

<style scoped lang="scss">
.selected-counter {
  box-sizing: content-box;
}
</style>
